<?php

# Credits
$wgExtensionCredits['other'][] = array(
  'name' => 'Capitalizer',
  'author' =>'Ron Nibbly',
  'url' => 'http://wiki.example.com/wiki/Caps',
  'description' => 'Capitalize all words in a string.',
  'version' => '1.0');

# Set up the hook, using different logic depending
# on the version of MediaWiki
if (defined('MW_SUPPORTS_PARSERFIRSTCALLINIT')) {
  $wgHooks['ParserFirstCallInit'][] = 'efCapitalizer_Setup';
} else {
  $wgExtensionFunctions[] = 'efCapitalizer_Setup';
}

# Set up magic word hook
$wgHooks['LanguageGetMagic'][] = 'efCapitalizer_Magic';

# Name the magic word
define('CAPITALIZER_NAME', 'caps');

function efCapitalizer_Setup($parser) {
  // Associate the parser function name with its implementation.
  $parser->setFunctionHook(CAPITALIZER_NAME, 'efCapitalizer_Render');
  return true;
}
 
function efCapitalizer_Magic(&$magicWords, $langID) {
  // Declare that your parser function name is a magic word.
  $magicWords[CAPITALIZER_NAME] = array( 0, CAPITALIZER_NAME );
  return true;
}
 
function efCapitalizer_Render(&$parser, $text) {
  // All the action happens here.
  // For more complicated behavior, define some PHP classes and
  // use them here.
  global $wgContLang;
  return $wgContLang->ucwords($text);
}
