<?php
# Credits
$wgExtensionCredits['other'][] = array(
  'name' => 'CategoryTagSorter',
  'author' =>'Ivan Knackerthrasher',
  'url' => 'http://wiki.example.com/wiki/CategoryTagSorter',
  'description' => 'Sort category tags displayed in an article.',
  'version' => '1.2');

# Set up hooks
$wgHooks['ParserLimitReport'][] = 'wfCategoryTagSorter';
$wgHooks['UserToggles'][] = 'wfCategoryTagSorterPref';

# Locate system messages
$wgExtensionMessagesFiles['CategoryTagSorter']
  = dirname(__FILE__) . '/CategoryTagSorter.i18n.php';

# Define a constant for the preference
define('CATEGORY_SORT_PREF', 'nocategorysort');

function wfCategoryTagSorter($parser, $text) {
  global $wgUser;
  if ($wgUser->getOption(CATEGORY_SORT_PREF) != 1) {
    $cats = $parser->mOutput->getCategories();
    ksort($cats);
    $parser->mOutput->setCategoryLinks($cats);
  }
  return true; // Required return value for hook callback functions
}

function wfCategoryTagSorterPref($toggles) {
  global $wgMessageCache;

  // Load our custom system messages
  wfLoadExtensionMessages('CategoryTagSorter');

  // Set up the preference
  $toggles[] = CATEGORY_SORT_PREF;
  $wgMessageCache->addMessage('tog-' . CATEGORY_SORT_PREF,
			      wfMsg('category-sort-preference'));

  return true; // Required return value for hook callback functions
}
