<?php

################################################################
# Sort the category tags on every article page.
################################################################

  // Do not execute outside of web context
if ( !isset( $_SERVER ) || !array_key_exists( 'REQUEST_METHOD', $_SERVER ) ) {
  return;
 }

// Credits
$wgExtensionCredits['other'][] = array(
				       'name' => 'CategoryTagSorter',
				       'author' =>'Dan Barrett',
				       'url' => 'http://wiki.example.com/wiki/Extension:CategoryTagSorter',
				       'description' => 'Sort the category tags when displaying an article.');

// Instantiate to run.
new CategoryTagSorter();

class CategoryTagSorter {
  const DISABLE_PREF = 'categorysortdisable';
  const DISABLE_DESC = 'Disable sorting of category links in articles';

  public function __construct() {
    global $wgHooks;
    // Choose a hook that executes only once after the parse.
    // Some like ParserBeforeTidy run several times.
    // Others like InternalParseBeforeLinks happen too early before
    // categories are set.
    $wgHooks['ParserLimitReport'][] = array($this, 'sort');
    $wgHooks['UserToggles'][] = array($this, 'toggle');
  }

  public function sort($parser, $text) {
    global $wgUser;
    if ($wgUser->getOption(self::DISABLE_PREF) != 1) {
      ksort($parser->mOutput->getCategories());
    }
    return true;
  }

  function toggle($extraToggles) {
    global $wgMessageCache;
    $extraToggles[] = self::DISABLE_PREF;
    $wgMessageCache->addMessage('tog-' . self::DISABLE_PREF,
				self::DISABLE_DESC);
    return true;
  }
}
