<?php

class ExternalImage {
  const NAME = 'extimg';

  function __construct() {
    // Set up tag
    global $wgExtensionFunctions;
    $wgExtensionFunctions[] = array($this, 'setupTag');

    // Set up parser function
    global $wgExtensionFunctions;
    $wgExtensionFunctions[] = array($this, 'setupPF');

    // Set up the magic word hook for parser function
    global $wgHooks;
    $wgHooks['LanguageGetMagic'][] = array($this, 'declareMagicWord');

  }

  function setupTag() {
    global $wgParser;
    $wgParser->setHook(self::NAME, array($this, 'renderTag'));
  }

  function renderTag($input, $argv) {
    return $this->render($input, $argv);
  }

  function setupPF() {
    global $wgParser;
    $wgParser->setFunctionHook(self::NAME, array($this, 'renderPF'));
  }
 
  function declareMagicWord( &$magicWords, $langID ) {
    $magicWords[self::NAME] = array( 0, self::NAME );
    return true;
  }

  function renderPF(&$parser, $input) {
    $argList = func_get_args();
    $argCount = func_num_args();
    $argv = array();

    // Process all arguments following $input
    for ($i=2; $i < $argCount; $i++) {
      $arg = $argList[$i];        // Get one argument
      $pair = split('=', $arg);   // Split it at the equals sign
      $name = trim($pair[0]);     // Isolate the parameter name
      $value = trim($pair[1]);    // Isolated the parameter value
      $argv[$name] = $value;      // Add to argv
    }

    return $this->render($input, $argv);
  }


  function render( $input, $argv ) {
    // Supported attributes of an img tag
    $imgAttributes = array('src', 'height', 'width');

    // Start constructing an img tag
    $imgTag .= "<img ";

    // Process the attributes passed to the tag
    foreach ($imgAttributes as $attribute) {
      // Ignore unknown attributes
      if (array_key_exists($attribute, $argv)) {
	$imgTag .= sprintf(' %s="%s"', $attribute, $argv[$attribute]);
      }
    }
    $imgTag .= '/>';

    // Prepend the caption ($input) and return the whole value
    // to be rendered in the wiki article.
    return sprintf("%s: %s", $input, $imgTag);
  }


}
