<?php
class SecureLoginPage {
  // On the login page, if nonsecure, flip to secure
  function secureLogin($junk) {
    global $wgCookieSecure;

    // Login cookies must be nonsecure so other pages see them
    $wgCookieSecure = false;

    // Secure the login page
    if ( ! self::isSecurePage() ) {
      self::flipProtocol('https');
    }
    return true;
  }

  // For all other pages, if secure, flip to nonsecure
  function otherPage($out) {
    global $wgTitle;
    if (! $wgTitle->isSpecial('Userlogin') && self::isSecurePage()) {
      self::flipProtocol('http');
    }
    return true;
  }

  // Are we on a secure page or not?
  private static function isSecurePage() {
    return isset($_SERVER['HTTPS'])
      && ($_SERVER['HTTPS'] == 'on');
  }

  // Switch from http to https or vice-versa
  private static function flipProtocol($protocol) {
    $domain = $_SERVER['HTTP_HOST'];
    $uri = $_SERVER['REQUEST_URI'];
    header("Location: $protocol://$domain$uri");
  }
}
