<?php

# Credits
$wgExtensionCredits['variable'][] = array(
  'name' => 'USER',
  'author' =>'Interstellar Stella',
  'url' => 'http://wiki.example.com/wiki/User_variable',
  'description' => 'Username of the current user.',
  'version' => '1.0');

# Set up hooks
$wgHooks['LanguageGetMagic'][] = 'efUserVariable_Magic';
$wgHooks['MagicWordwgVariableIDs'][] = 'efUserVariable_Var';
$wgHooks['ParserGetVariableValueSwitch'][] = 'efUserVariable_Set';

# Define constants
define('NAME_USER', 'USER');
define('MAG_USER', 'uservariable');

# Callback functions
function efUserVariable_Magic(&$magicWords, &$langID) {
  // Declare that USER is a magic word by adding it to the 
  // magic words array.
  $magicWords[MAG_USER] = array(0, NAME_USER);
  return true;
}

function efUserVariable_Var(&$variables) {
  // Declare that USER is a variable by adding it to the
  // variable array
  $variables[] = MAG_USER;
  return true;
}

function efUserVariable_Set(&$parser, &$cache, &$id, &$returnValue) {
  global $wgUser;

  if ($id == MAG_USER) {
    // Disable cache so current username is displayed
    $parser->disableCache();

    // Associate a value with USER
    $returnValue = $wgUser->getName();
    return true;
  }
  return false;
}
