<?php

class UserVariable {
  // The variable name available to wiki users.
  const NAME_USER = 'USER';
  // An internal ID for the variable. Can be anything.
  const MAG_USER = 'uservariable';

  // Declare that USER is a magic word by adding it to the magic words
  // array.
  public function declareMagicWord(&$magicWords, &$langID) {
    $magicWords[self::MAG_USER] = array(0, self::NAME_USER);
    return true;
  }

  // Declare that USER is a variable by adding it to the variable array
  public function declareVariable(&$variables) {
    $variables[] = self::MAG_USER;
    return true;
  }

  // Associate a value with USER
  public function setValue(&$parser, &$cache, &$id, &$returnValue) {
    if ($id == self::MAG_USER) {
      // Disable cache so current username is displayed
      $parser->disableCache();

      // Get username
      global $wgUser;
      $returnValue = $wgUser->getName();
      return true;
    }
    return false;
  }
}
